// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/include/dio32_utils.h $
// $Rev: 54529 $
// $Date: 2024-05-28 09:29:00 -0500 (Tue, 28 May 2024) $

// DIO32: Utilities: header file

#ifndef	__DIO32_UTILS_H__
#define	__DIO32_UTILS_H__

#include "dio32_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	dio32_close_util			(int fd, int index, int verbose);
int	dio32_init_util				(int verbose);
int dio32_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	dio32_open_util				(int device, int share, int index, int verbose, int* fd);
int dio32_read_util				(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);

// IOCTL utility services

int	dio32_deglitch_filter		(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_DEGLITCH_FILTER
int	dio32_deglitch_rate			(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_DEGLITCH_RATE
int	dio32_hl_out_mask			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_HL_OUT_MASK
int	dio32_hl_out_tri_state		(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_HL_OUT_TRI_STATE
int	dio32_hl_out_value			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_HL_OUT_VALUE
int	dio32_initialize			(int fd, int index, int verbose);														// DIO32_IOCTL_INITIALIZE
int	dio32_io_in_deglitched_get	(int fd, int index, int verbose, u32* get);												// DIO32_IOCTL_IO_IN_DEGLITCHED_GET
int	dio32_io_in_get				(int fd, int index, int verbose, u32* get);												// DIO32_IOCTL_IO_IN_GET
int	dio32_io_out_clock			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_IO_OUT_CLOCK
int	dio32_io_out_dir			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_IO_OUT_DIR
int	dio32_io_out_tri_state		(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_IO_OUT_TRI_STATE
int	dio32_io_out_val			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_IO_OUT_VAL
int	dio32_irq_hl_enable			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_IRQ_HL_ENABLE
int	dio32_irq_lh_enable			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_IRQ_LH_ENABLE
int	dio32_led0					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_LED0
int	dio32_led1					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_LED1
int	dio32_led2					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_LED2
int	dio32_led3					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_LED3
int	dio32_led4					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_LED4
int	dio32_led5					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_LED5
int	dio32_lh_out_mask			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_LH_OUT_MASK
int	dio32_lh_out_tri_state		(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_LH_OUT_TRI_STATE
int	dio32_lh_out_value			(int fd, int index, int verbose, s32 port, s32 action, u32 mask, u32 set, u32* get);	// DIO32_IOCTL_LH_OUT_VALUE
int	dio32_query					(int fd, int index, int verbose, s32 set, s32* get);									// DIO32_IOCTL_QUERY
int	dio32_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);							// DIO32_IOCTL_REG_MOD
int	dio32_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);									// DIO32_IOCTL_REG_READ
int	dio32_reg_write				(int fd, int index, int verbose, u32 reg, u32 value);									// DIO32_IOCTL_REG_WRITE
int	dio32_wait_cancel			(int fd, int index, int verbose, dio32_wait_t* wait);									// DIO32_IOCTL_WAIT_CANCEL
int	dio32_wait_event			(int fd, int index, int verbose, dio32_wait_t* wait);									// DIO32_IOCTL_WAIT_EVENT
int	dio32_wait_status			(int fd, int index, int verbose, dio32_wait_t* wait);									// DIO32_IOCTL_WAIT_STATUS

// Auxiliary utility services

int dio32_id_device				(int fd, int index, int verbose);

int	dio32_count_boards			(int verbose, s32* get);
int dio32_id_driver				(void);
int	dio32_reg_list				(int fd, int detail);

const gsc_reg_def_t*			dio32_reg_get_def_id(u32 reg);
const gsc_reg_def_t*			dio32_reg_get_def_index(int index);
const char*						dio32_reg_get_desc(u32 reg);
const char*						dio32_reg_get_name(u32 reg);



#endif
