// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/bbtest/main.h $
// $Rev: 54531 $
// $Date: 2024-05-28 09:31:25 -0500 (Tue, 28 May 2024) $

// DIO32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdlib.h>
#include <time.h>

#include "dio32_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index_1;		// device index
	s32	index_2;		// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd_1;			// File descriptor for device to access.
	int	fd_2;			// File descriptor for device to access.

	// Device Settings

} args_t;

typedef struct
{
	s32	index;
	int	fd;
} dio_t;



// prototypes *****************************************************************

int	auto_trans_tests(const dio_t* dta, const dio_t* dtb);
int	gpio_tests		(const dio_t* dta, const dio_t* dtb);
int	perform_tests	(const args_t* args);



#endif
