// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/led/perform.c $
// $Rev: 51806 $
// $Date: 2022-10-14 12:33:33 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _led_pattern(const args_t* args, s32 color_all, int index, s32 color_one)
{
	s32	cmds[6]	=
	{
		DIO32_IOCTL_LED0,
		DIO32_IOCTL_LED1,
		DIO32_IOCTL_LED2,
		DIO32_IOCTL_LED3,
		DIO32_IOCTL_LED4,
		DIO32_IOCTL_LED5,
	};

	s32	arg;
	int	errs	= 0;
	int	i;
	int	ret;

	for (i = 0; i <= 5; i++)
	{
		if (i == index)
			arg	= color_one;
		else
			arg	= color_all;

		ret		= dio32_ioctl(args->fd, cmds[i], &arg);
		errs	+= ret ? 1 : 0;
	}

	os_sleep_ms(250);
	return(errs);
}



//*****************************************************************************
static int _cycle_leds(const args_t* args, s32 color, const char* name)
{
	int	errs	= 0;
	int	i;

	gsc_label(name);

	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);
	errs	+= _led_pattern(args, color, 0, color);
	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);
	errs	+= _led_pattern(args, color, 0, color);
	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);

	for (i = 0; i <= 5; i++)
		errs	+= _led_pattern(args, DIO32_LED_OFF, i, color);

	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);

	for (i = 5; i >= 0; i--)
		errs	+= _led_pattern(args, DIO32_LED_OFF, i, color);

	for (i = 0; i <= 5; i++)
		errs	+= _led_pattern(args, color, i, DIO32_LED_OFF);

	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);

	for (i = 5; i >= 0; i--)
		errs	+= _led_pattern(args, color, i, DIO32_LED_OFF);

	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);
	errs	+= _led_pattern(args, color, 0, color);
	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);
	errs	+= _led_pattern(args, color, 0, color);
	errs	+= _led_pattern(args, DIO32_LED_OFF, 0, DIO32_LED_OFF);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	gsc_label("Cycling LEDs");
	printf("\n");
	gsc_label_level_inc();

	errs	+= _cycle_leds(args, DIO32_LED_GREEN,	"Green"			);
	errs	+= _cycle_leds(args, DIO32_LED_RED,		"Red"			);
	errs	+= _cycle_leds(args, DIO32_LED_BOTH,	"Green & Red"	);

	gsc_label_level_dec();
	return(errs);
}


