// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/deglitch_rate.c $
// $Rev: 54538 $
// $Date: 2024-05-28 09:36:47 -0500 (Tue, 28 May 2024) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* line		*/	__LINE__,
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DIO32_IOCTL_DEGLITCH_RATE,
			/* arg		*/	0,
			/* reg		*/	DIO32_GSC_DGCR,
			/* mask		*/	0xFFFFFF00,
			/* value	*/	0
		},

		{ 0, SERVICE_END_LIST }
	};

	int errs	= 0;
	int	i;
	int	ret;
	s32	val;

	// Walking one.
	errs	+= dio32_initialize(fd, -1, 0);

	for (i = 0; i <= 23; i++)
	{
		list[0].arg		= (1 << (i + 8)) & 0xFFFFFF;
		list[0].value	= list[0].arg << 8;

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);
	}

	// Walking zero.
	errs	+= dio32_initialize(fd, -1, 0);

	for (i = 0; i <= 23; i++)
	{
		list[0].arg		= (~(1 << (i + 8))) & 0xFFFFFF;
		list[0].value	= list[0].arg << 8;

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);
	}

	// Verify that errors are reported
	errs	+= dio32_initialize(fd, -1, 0);

	val	= 0xFFFFFFFF;
	ret	= dio32_ioctl(fd, DIO32_IOCTL_DEGLITCH_RATE, &val);

	if (ret)
	{
		errs++;
		printf("FAIL <---  (%d. failure reported, but shouldn't)\n", __LINE__);
	}

	val	= 0x1000000;
	ret	= dio32_ioctl(fd, DIO32_IOCTL_DEGLITCH_RATE, &val);

	if (ret == 0)
	{
		errs	= 1;
		printf("FAIL <---  (%d. failure not reported)\n", __LINE__);
	}

	errs	+= dio32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	return(errs);
}



/******************************************************************************
*
*	Function:	deglitch_rate_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_DEGLITCH_RATE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int deglitch_rate_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_DEGLITCH_RATE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


