// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/initialize.c $
// $Rev: 54538 $
// $Date: 2024-05-28 09:36:47 -0500 (Tue, 28 May 2024) $

// DIO32: Sample Application: source file

#include "main.h"



// variables ******************************************************************

static const struct
{
	u32	reg;
	u32	value;
	u32	mask;
} _reg_list[]	=
{
	// reg						value		mask
	{ DIO32_GSC_BCR,			0x00000FFF,	0x80000FFF		},

	{ DIO32_GSC_IODR,			0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_OTSR,			0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_OVR,			0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_OCR,			0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_DGCR,			0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_LHIER,			0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_HLIER,			0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D00LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D00LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D00LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D00HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D00HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D00HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D01LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D01LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D01LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D01HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D01HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D01HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D02LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D02LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D02LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D02HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D02HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D02HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D03LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D03LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D03LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D03HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D03HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D03HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D04LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D04LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D04LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D04HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D04HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D04HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D05LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D05LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D05LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D05HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D05HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D05HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D06LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D06LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D06LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D06HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D06HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D06HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D07LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D07LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D07LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D07HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D07HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D07HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D08LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D08LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D08LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D08HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D08HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D08HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D09LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D09LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D09LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D09HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D09HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D09HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D10LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D10LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D10LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D10HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D10HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D10HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D11LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D11LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D11LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D11HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D11HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D11HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D12LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D12LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D12LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D12HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D12HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D12HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D13LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D13LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D13LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D13HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D13HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D13HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D14LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D14LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D14LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D14HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D14HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D14HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D15LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D15LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D15LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D15HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D15HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D15HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D16LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D16LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D16LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D16HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D16HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D16HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D17LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D17LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D17LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D17HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D17HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D17HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D18LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D18LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D18LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D18HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D18HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D18HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D19LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D19LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D19LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D19HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D19HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D19HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D20LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D20LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D20LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D20HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D20HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D20HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D21LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D21LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D21LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D21HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D21HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D21HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D22LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D22LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D22LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D22HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D22HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D22HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D23LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D23LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D23LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D23HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D23HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D23HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D24LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D24LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D24LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D24HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D24HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D24HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D25LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D25LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D25LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D25HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D25HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D25HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D26LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D26LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D26LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D26HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D26HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D26HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D27LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D27LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D27LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D27HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D27HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D27HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D28LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D28LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D28LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D28HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D28HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D28HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D29LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D29LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D29LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D29HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D29HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D29HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D30LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D30LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D30LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D30HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D30HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D30HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},

	{ DIO32_GSC_D31LHOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D31LHOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D31LHOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D31HLOMR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D31HLOVR,		0xFFFFFFFF,	0xFFFFFFFF		},
	{ DIO32_GSC_D31HLOTSR,		0xFFFFFFFF,	0xFFFFFFFF		},
};



//*****************************************************************************
static int _fill_regs(int fd)
{
	int			errs	= 0;
	int			i;
	gsc_reg_t	parm;
	int			ret;

	// Write the specified values to the listed registers.

	for (i = 0; i < SIZEOF_ARRAY(_reg_list); i++)
	{
		parm.reg	= _reg_list[i].reg;
		parm.value	= _reg_list[i].value;
		parm.mask	= 0xBEEFDEAD;
		ret			= dio32_ioctl(fd, DIO32_IOCTL_REG_WRITE, (void*) &parm);

		if (ret)
		{
			errs++;
			printf(	"FAIL <---  (%d. i %d, dio32_ioctl() failure, error %d)\n",
					__LINE__,
					i,
					ret);
			continue;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _test_regs(int fd)
{
	int			errs	= 0;
	int			i;
	gsc_reg_t	parm;
	int			ret;

	// Read the registers and verify the specified bits.

	for (i = 0; i < SIZEOF_ARRAY(_reg_list); i++)
	{
		parm.reg	= _reg_list[i].reg;
		parm.value	= 0xBEEFDEAD;
		parm.mask	= 0xBEEFDEAD;
		ret			= dio32_ioctl(fd, DIO32_IOCTL_REG_READ, (void*) &parm);

		if (ret)
		{
			errs++;
			printf(	"FAIL <---  (%d. i %d, dio32_ioctl() failure, error %d)\n",
					__LINE__,
					i,
					ret);
			continue;
		}

		if (parm.value & _reg_list[i].mask)
		{
			errs	= 1;
			printf(	"FAIL <---  (%d. i %d, mask 0x%lX, got 0x%lX, expected 0x0)\n",
					__LINE__,
					i,
					(long) _reg_list[i].mask,
					(long) parm.value);
			continue;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{				// Perform the initialization.
			/* line		*/	__LINE__,
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	DIO32_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	DIO32_GSC_BCR,
			/* mask		*/	0x80000000,
			/* value	*/	0x00000000
		},

		{ 0, SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= dio32_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= dio32_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int errs	= 0;

	errs	+= dio32_initialize(fd, -1, 0);
	errs	+= _fill_regs(fd);
	errs	+= dio32_initialize(fd, -1, 0);
	errs	+= _test_regs(fd);
	return(errs);
}



/******************************************************************************
*
*	Function:	initialize_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_INITIALIZE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int initialize_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_INITIALIZE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


