// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/main.h $
// $Rev: 54538 $
// $Date: 2024-05-28 09:36:47 -0500 (Tue, 28 May 2024) $

// DIO32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <errno.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "dio32_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	D0						(1 << 0)
#define	D1						(1 << 1)
#define	D2						(1 << 2)
#define	D3						(1 << 3)
#define	D4						(1 << 4)
#define	D5						(1 << 5)
#define	D6						(1 << 6)
#define	D7						(1 << 7)
#define	D8						(1 << 8)
#define	D9						(1 << 9)

#define	D10						(1 << 10)
#define	D11						(1 << 11)
#define	D12						(1 << 12)
#define	D13						(1 << 13)
#define	D14						(1 << 14)
#define	D15						(1 << 15)
#define	D16						(1 << 16)
#define	D17						(1 << 17)
#define	D18						(1 << 18)
#define	D19						(1 << 19)

#define	D20						(1 << 20)
#define	D21						(1 << 21)
#define	D22						(1 << 22)
#define	D23						(1 << 23)
#define	D24						(1 << 24)
#define	D25						(1 << 25)
#define	D26						(1 << 26)
#define	D27						(1 << 27)
#define	D28						(1 << 28)
#define	D29						(1 << 29)

#define	D30						(1 << 30)
#define	D31						(1 << 31)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for the device to access.

	// Device Settings

} args_t;

typedef enum
{
	SERVICE_END_LIST,	// Ends list of service_data_t structures.
	SERVICE_NONE,		// Do nothing.
	SERVICE_NORMAL,
	SERVICE_REG_MOD,
	SERVICE_REG_READ,
	SERVICE_REG_SHOW,
	SERVICE_REG_TEST,
	SERVICE_REG_WRITE,	// arg = # of times to write
	SERVICE_SLEEP,		// arg = # of seconds to sleep
	SERVICE_SLEEP_MS,	// arg = # of milliseconds to sleep
	SERVICE_IOCTL_GET,
	SERVICE_IOCTL_SET
} service_t;

typedef struct
{
	int				line;		// __LINE__
	service_t		service;	// service_t
	int				cmd;		// IOCTL code
	unsigned long	arg;		// The IOCTL data argument.
	u32				reg;		// 0 = ignore
	u32				mask;		// The register bits of interest.
	u32				value;		// The value expected for the bits of interest.
} service_data_t;



// variables ******************************************************************

extern	const u32 hlomr_reg_list[32];
extern	const u32 hlotsr_reg_list[32];
extern	const u32 hlovr_reg_list[32];

extern	const u32 lhomr_reg_list[32];
extern	const u32 lhotsr_reg_list[32];
extern	const u32 lhovr_reg_list[32];




// prototypes *****************************************************************

int	deglitch_filter_test(int fd);		// DIO32_IOCTL_DEGLITCH_FILTER
int	deglitch_rate_test(int fd);			// DIO32_IOCTL_DEGLITCH_RATE

int	hl_out_mask_test(int fd);			// DIO32_IOCTL_HL_OUT_MASK
int	hl_out_tri_state_test(int fd);		// DIO32_IOCTL_HL_OUT_TRI_STATE
int	hl_out_value_test(int fd);			// DIO32_IOCTL_HL_OUT_VALUE

int	initialize_test(int fd);			// DIO32_IOCTL_INITIALIZE
int	input_response_service_test(int fd, int cmd, int port, int reg);

int	io_in_deglitched_get_test(int fd);	// DIO32_IOCTL_IO_IN_DEGLITCHED_GET
int	io_in_get_test(int fd);				// DIO32_IOCTL_IO_IN_GET
int	io_out_clock_test(int fd);			// DIO32_IOCTL_IO_OUT_CLOCK
int	io_out_dir_test(int fd);			// DIO32_IOCTL_IO_OUT_DIR
int	io_out_tri_state_test(int fd);		// DIO32_IOCTL_IO_OUT_TRI_STATE
int	io_out_val_test(int fd);			// DIO32_IOCTL_IO_OUT_VAL

int	irq_hl_enable_test(int fd);			// DIO32_IOCTL_IRQ_HL_ENABLE
int	irq_lh_enable_test(int fd);			// DIO32_IOCTL_IRQ_LH_ENABLE
int	led0_test(int fd);					// DIO32_IOCTL_LED0
int	led1_test(int fd);					// DIO32_IOCTL_LED1
int	led2_test(int fd);					// DIO32_IOCTL_LED2
int	led3_test(int fd);					// DIO32_IOCTL_LED3
int	led4_test(int fd);					// DIO32_IOCTL_LED4
int	led5_test(int fd);					// DIO32_IOCTL_LED5

int	lh_out_mask_test(int fd);			// DIO32_IOCTL_LH_OUT_MASK
int	lh_out_tri_state_test(int fd);		// DIO32_IOCTL_LH_OUT_TRI_STATE
int	lh_out_value_test(int fd);			// DIO32_IOCTL_LH_OUT_VALUE

int	perform_tests(const args_t* args);

int	query_test(int fd);					// DIO32_IOCTL_QUERY

int	reg_mod_test(int fd);				// DIO32_IOCTL_REG_MOD
int	reg_read_test(int fd);				// DIO32_IOCTL_REG_READ
int	reg_write_test(int fd);				// DIO32_IOCTL_REG_WRITE

int	service_ioctl_reg_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_reg_list(int fd, const service_data_t* list);

int	wait_cancel_test(int fd);			// DIO32_IOCTL_WAIT_CANCEL
int	wait_event_test(int fd);			// DIO32_IOCTL_WAIT_EVENT
int	wait_status_test(int fd);			// DIO32_IOCTL_WAIT_STATUS



#endif
