// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/query.c $
// $Rev: 54538 $
// $Date: 2024-05-28 09:36:47 -0500 (Tue, 28 May 2024) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i		= 0;
	int	tmp;

	errs	= dio32_query(fd, -1, 0, DIO32_QUERY_COUNT, &count);

	if (count != (DIO32_IOCTL_QUERY_LAST))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) DIO32_IOCTL_QUERY_LAST,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i < DIO32_IOCTL_QUERY_LAST); i++)
			errs	= dio32_query(fd, -1, 0, i, &data);
	}

	// Verify that errors are reported.
	data	= 0;
	tmp		= dio32_query(fd, -1, 0, 999, &data);

	if ((tmp == 0) || (data != -1))
	{
		errs	= 1;
		printf("FAIL <---  (%d. failure not reported)\n", __LINE__);
	}

	data	= 0;
	tmp		= dio32_query(fd, -1, 0, -2, &data);

	if ((tmp == 0) || (data != -1))
	{
		errs	= 1;
		printf("FAIL <---  (%d. failure not reported)\n", __LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


