// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/reg_read.c $
// $Rev: 51807 $
// $Date: 2022-10-14 12:34:33 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There is nothing to do here.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const struct
	{
		u32	reg;
		u32	value;
	} list[]	=
	{
		// reg						value
		{ GSC_PCI_9056_VIDR,		0x10B5	},
		{ GSC_PCI_9056_SVID,		0x10B5	},

		{ GSC_PLX_9056_VIDR,		0x10B5	},

		{ DIO32_GSC_FRR,			0		},
		{ DIO32_GSC_FR,				0		},
		{ DIO32_GSC_BCR,			0		},
		{ DIO32_GSC_BSR,			0		},
		{ DIO32_GSC_ITR,			0		},

		{ DIO32_GSC_IODR,			0		},
		{ DIO32_GSC_PIR,			0		},
		{ DIO32_GSC_DGIR,			0		},

		{ DIO32_GSC_OTSR,			0		},
		{ DIO32_GSC_OVR,			0		},
		{ DIO32_GSC_OCR,			0		},

		{ DIO32_GSC_DGCR,			0		},

		{ DIO32_GSC_PC1R,			0		},
		{ DIO32_GSC_PC1PWMDR,		0		},
		{ DIO32_GSC_PC1FR,			0		},

		{ DIO32_GSC_PC2R,			0		},
		{ DIO32_GSC_PC2PWMDR,		0		},
		{ DIO32_GSC_PC2FR,			0		},

		{ DIO32_GSC_PC3R,			0		},
		{ DIO32_GSC_PC3PWMDR,		0		},
		{ DIO32_GSC_PC3FR,			0		},

		{ DIO32_GSC_LHIER,			0		},
		{ DIO32_GSC_LHISCR,			0		},
		{ DIO32_GSC_HLIER,			0		},
		{ DIO32_GSC_HLISCR,			0		},

		{ DIO32_GSC_D00LHOMR,		0		},
		{ DIO32_GSC_D00LHOVR,		0		},
		{ DIO32_GSC_D00LHOTSR,		0		},
		{ DIO32_GSC_D00HLOMR,		0		},
		{ DIO32_GSC_D00HLOVR,		0		},
		{ DIO32_GSC_D00HLOTSR,		0		},

		{ DIO32_GSC_D01LHOMR,		0		},
		{ DIO32_GSC_D01LHOVR,		0		},
		{ DIO32_GSC_D01LHOTSR,		0		},
		{ DIO32_GSC_D01HLOMR,		0		},
		{ DIO32_GSC_D01HLOVR,		0		},
		{ DIO32_GSC_D01HLOTSR,		0		},

		{ DIO32_GSC_D02LHOMR,		0		},
		{ DIO32_GSC_D02LHOVR,		0		},
		{ DIO32_GSC_D02LHOTSR,		0		},
		{ DIO32_GSC_D02HLOMR,		0		},
		{ DIO32_GSC_D02HLOVR,		0		},
		{ DIO32_GSC_D02HLOTSR,		0		},

		{ DIO32_GSC_D03LHOMR,		0		},
		{ DIO32_GSC_D03LHOVR,		0		},
		{ DIO32_GSC_D03LHOTSR,		0		},
		{ DIO32_GSC_D03HLOMR,		0		},
		{ DIO32_GSC_D03HLOVR,		0		},
		{ DIO32_GSC_D03HLOTSR,		0		},

		{ DIO32_GSC_D04LHOMR,		0		},
		{ DIO32_GSC_D04LHOVR,		0		},
		{ DIO32_GSC_D04LHOTSR,		0		},
		{ DIO32_GSC_D04HLOMR,		0		},
		{ DIO32_GSC_D04HLOVR,		0		},
		{ DIO32_GSC_D04HLOTSR,		0		},

		{ DIO32_GSC_D05LHOMR,		0		},
		{ DIO32_GSC_D05LHOVR,		0		},
		{ DIO32_GSC_D05LHOTSR,		0		},
		{ DIO32_GSC_D05HLOMR,		0		},
		{ DIO32_GSC_D05HLOVR,		0		},
		{ DIO32_GSC_D05HLOTSR,		0		},

		{ DIO32_GSC_D06LHOMR,		0		},
		{ DIO32_GSC_D06LHOVR,		0		},
		{ DIO32_GSC_D06LHOTSR,		0		},
		{ DIO32_GSC_D06HLOMR,		0		},
		{ DIO32_GSC_D06HLOVR,		0		},
		{ DIO32_GSC_D06HLOTSR,		0		},

		{ DIO32_GSC_D07LHOMR,		0		},
		{ DIO32_GSC_D07LHOVR,		0		},
		{ DIO32_GSC_D07LHOTSR,		0		},
		{ DIO32_GSC_D07HLOMR,		0		},
		{ DIO32_GSC_D07HLOVR,		0		},
		{ DIO32_GSC_D07HLOTSR,		0		},

		{ DIO32_GSC_D08LHOMR,		0		},
		{ DIO32_GSC_D08LHOVR,		0		},
		{ DIO32_GSC_D08LHOTSR,		0		},
		{ DIO32_GSC_D08HLOMR,		0		},
		{ DIO32_GSC_D08HLOVR,		0		},
		{ DIO32_GSC_D08HLOTSR,		0		},

		{ DIO32_GSC_D09LHOMR,		0		},
		{ DIO32_GSC_D09LHOVR,		0		},
		{ DIO32_GSC_D09LHOTSR,		0		},
		{ DIO32_GSC_D09HLOMR,		0		},
		{ DIO32_GSC_D09HLOVR,		0		},
		{ DIO32_GSC_D09HLOTSR,		0		},

		{ DIO32_GSC_D10LHOMR,		0		},
		{ DIO32_GSC_D10LHOVR,		0		},
		{ DIO32_GSC_D10LHOTSR,		0		},
		{ DIO32_GSC_D10HLOMR,		0		},
		{ DIO32_GSC_D10HLOVR,		0		},
		{ DIO32_GSC_D10HLOTSR,		0		},

		{ DIO32_GSC_D11LHOMR,		0		},
		{ DIO32_GSC_D11LHOVR,		0		},
		{ DIO32_GSC_D11LHOTSR,		0		},
		{ DIO32_GSC_D11HLOMR,		0		},
		{ DIO32_GSC_D11HLOVR,		0		},
		{ DIO32_GSC_D11HLOTSR,		0		},

		{ DIO32_GSC_D12LHOMR,		0		},
		{ DIO32_GSC_D12LHOVR,		0		},
		{ DIO32_GSC_D12LHOTSR,		0		},
		{ DIO32_GSC_D12HLOMR,		0		},
		{ DIO32_GSC_D12HLOVR,		0		},
		{ DIO32_GSC_D12HLOTSR,		0		},

		{ DIO32_GSC_D13LHOMR,		0		},
		{ DIO32_GSC_D13LHOVR,		0		},
		{ DIO32_GSC_D13LHOTSR,		0		},
		{ DIO32_GSC_D13HLOMR,		0		},
		{ DIO32_GSC_D13HLOVR,		0		},
		{ DIO32_GSC_D13HLOTSR,		0		},

		{ DIO32_GSC_D14LHOMR,		0		},
		{ DIO32_GSC_D14LHOVR,		0		},
		{ DIO32_GSC_D14LHOTSR,		0		},
		{ DIO32_GSC_D14HLOMR,		0		},
		{ DIO32_GSC_D14HLOVR,		0		},
		{ DIO32_GSC_D14HLOTSR,		0		},

		{ DIO32_GSC_D15LHOMR,		0		},
		{ DIO32_GSC_D15LHOVR,		0		},
		{ DIO32_GSC_D15LHOTSR,		0		},
		{ DIO32_GSC_D15HLOMR,		0		},
		{ DIO32_GSC_D15HLOVR,		0		},
		{ DIO32_GSC_D15HLOTSR,		0		},

		{ DIO32_GSC_D16LHOMR,		0		},
		{ DIO32_GSC_D16LHOVR,		0		},
		{ DIO32_GSC_D16LHOTSR,		0		},
		{ DIO32_GSC_D16HLOMR,		0		},
		{ DIO32_GSC_D16HLOVR,		0		},
		{ DIO32_GSC_D16HLOTSR,		0		},

		{ DIO32_GSC_D17LHOMR,		0		},
		{ DIO32_GSC_D17LHOVR,		0		},
		{ DIO32_GSC_D17LHOTSR,		0		},
		{ DIO32_GSC_D17HLOMR,		0		},
		{ DIO32_GSC_D17HLOVR,		0		},
		{ DIO32_GSC_D17HLOTSR,		0		},

		{ DIO32_GSC_D18LHOMR,		0		},
		{ DIO32_GSC_D18LHOVR,		0		},
		{ DIO32_GSC_D18LHOTSR,		0		},
		{ DIO32_GSC_D18HLOMR,		0		},
		{ DIO32_GSC_D18HLOVR,		0		},
		{ DIO32_GSC_D18HLOTSR,		0		},

		{ DIO32_GSC_D19LHOMR,		0		},
		{ DIO32_GSC_D19LHOVR,		0		},
		{ DIO32_GSC_D19LHOTSR,		0		},
		{ DIO32_GSC_D19HLOMR,		0		},
		{ DIO32_GSC_D19HLOVR,		0		},
		{ DIO32_GSC_D19HLOTSR,		0		},

		{ DIO32_GSC_D20LHOMR,		0		},
		{ DIO32_GSC_D20LHOVR,		0		},
		{ DIO32_GSC_D20LHOTSR,		0		},
		{ DIO32_GSC_D20HLOMR,		0		},
		{ DIO32_GSC_D20HLOVR,		0		},
		{ DIO32_GSC_D20HLOTSR,		0		},

		{ DIO32_GSC_D21LHOMR,		0		},
		{ DIO32_GSC_D21LHOVR,		0		},
		{ DIO32_GSC_D21LHOTSR,		0		},
		{ DIO32_GSC_D21HLOMR,		0		},
		{ DIO32_GSC_D21HLOVR,		0		},
		{ DIO32_GSC_D21HLOTSR,		0		},

		{ DIO32_GSC_D22LHOMR,		0		},
		{ DIO32_GSC_D22LHOVR,		0		},
		{ DIO32_GSC_D22LHOTSR,		0		},
		{ DIO32_GSC_D22HLOMR,		0		},
		{ DIO32_GSC_D22HLOVR,		0		},
		{ DIO32_GSC_D22HLOTSR,		0		},

		{ DIO32_GSC_D23LHOMR,		0		},
		{ DIO32_GSC_D23LHOVR,		0		},
		{ DIO32_GSC_D23LHOTSR,		0		},
		{ DIO32_GSC_D23HLOMR,		0		},
		{ DIO32_GSC_D23HLOVR,		0		},
		{ DIO32_GSC_D23HLOTSR,		0		},

		{ DIO32_GSC_D24LHOMR,		0		},
		{ DIO32_GSC_D24LHOVR,		0		},
		{ DIO32_GSC_D24LHOTSR,		0		},
		{ DIO32_GSC_D24HLOMR,		0		},
		{ DIO32_GSC_D24HLOVR,		0		},
		{ DIO32_GSC_D24HLOTSR,		0		},

		{ DIO32_GSC_D25LHOMR,		0		},
		{ DIO32_GSC_D25LHOVR,		0		},
		{ DIO32_GSC_D25LHOTSR,		0		},
		{ DIO32_GSC_D25HLOMR,		0		},
		{ DIO32_GSC_D25HLOVR,		0		},
		{ DIO32_GSC_D25HLOTSR,		0		},

		{ DIO32_GSC_D26LHOMR,		0		},
		{ DIO32_GSC_D26LHOVR,		0		},
		{ DIO32_GSC_D26LHOTSR,		0		},
		{ DIO32_GSC_D26HLOMR,		0		},
		{ DIO32_GSC_D26HLOVR,		0		},
		{ DIO32_GSC_D26HLOTSR,		0		},

		{ DIO32_GSC_D27LHOMR,		0		},
		{ DIO32_GSC_D27LHOVR,		0		},
		{ DIO32_GSC_D27LHOTSR,		0		},
		{ DIO32_GSC_D27HLOMR,		0		},
		{ DIO32_GSC_D27HLOVR,		0		},
		{ DIO32_GSC_D27HLOTSR,		0		},

		{ DIO32_GSC_D28LHOMR,		0		},
		{ DIO32_GSC_D28LHOVR,		0		},
		{ DIO32_GSC_D28LHOTSR,		0		},
		{ DIO32_GSC_D28HLOMR,		0		},
		{ DIO32_GSC_D28HLOVR,		0		},
		{ DIO32_GSC_D28HLOTSR,		0		},

		{ DIO32_GSC_D29LHOMR,		0		},
		{ DIO32_GSC_D29LHOVR,		0		},
		{ DIO32_GSC_D29LHOTSR,		0		},
		{ DIO32_GSC_D29HLOMR,		0		},
		{ DIO32_GSC_D29HLOVR,		0		},
		{ DIO32_GSC_D29HLOTSR,		0		},

		{ DIO32_GSC_D30LHOMR,		0		},
		{ DIO32_GSC_D30LHOVR,		0		},
		{ DIO32_GSC_D30LHOTSR,		0		},
		{ DIO32_GSC_D30HLOMR,		0		},
		{ DIO32_GSC_D30HLOVR,		0		},
		{ DIO32_GSC_D30HLOTSR,		0		},

		{ DIO32_GSC_D31LHOMR,		0		},
		{ DIO32_GSC_D31LHOVR,		0		},
		{ DIO32_GSC_D31LHOTSR,		0		},
		{ DIO32_GSC_D31HLOMR,		0		},
		{ DIO32_GSC_D31HLOVR,		0		},
		{ DIO32_GSC_D31HLOTSR,		0		},

	};

	int			errs	= 0;
	int			i;
	gsc_reg_t	parm;
	int			ret;

	errs	+= dio32_initialize(fd, -1, 0);

	for (i = 0; i < SIZEOF_ARRAY(list); i++)
	{
		parm.reg	= list[i].reg;
		parm.value	= 0xDEADBEEF;
		parm.mask	= 0xBEEFDEAD;
		ret			= dio32_ioctl(fd, DIO32_IOCTL_REG_READ, (void*) &parm);

		if (ret)
		{
			errs++;
			printf(	"FAIL <---  (%d. i %d, dio32_ioctl() failure, error %d)\n",
					__LINE__,
					i,
					ret);
			continue;
		}

		if (parm.value == 0xDEADBEEF)
		{
			errs	= 1;
			printf("FAIL <---  (%d. i %d, value not changed)\n", __LINE__, i);
			continue;
		}

		if (parm.mask != 0xBEEFDEAD)
		{
			errs	= 1;
			printf("FAIL <---  (%d. i %d, mask changed)\n", __LINE__, i);
			continue;
		}

		if ((list[i].value) && (parm.value != list[i].value))
		{
			errs	= 1;
			printf(	"FAIL <---  (%d. i %d, got 0x%08lX, expected 0x%08lX)\n",
					__LINE__,
					i,
					(long) parm.value,
					(long) list[i].value);
			continue;
		}
	}

	errs	+= dio32_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	reg_read_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_REG_READ.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int reg_read_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_REG_READ");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


