// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/reg_write.c $
// $Rev: 51807 $
// $Date: 2022-10-14 12:34:33 -0500 (Fri, 14 Oct 2022) $

// DIO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There is nothing to do here.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const struct
	{
		u32	reg;
		u32	value;
		u32	mask;
	} list[]	=
	{
		// reg						value		mask
		{ DIO32_GSC_BCR,			0x00000000,	0x80000FFF		},

		{ DIO32_GSC_IODR,			0x5555AAA1,	0xFFFFFFFF		},

		{ DIO32_GSC_OTSR,			0x5555AAA2,	0xFFFFFFFF		},
		{ DIO32_GSC_OVR,			0x5555AAA3,	0xFFFFFFFF		},
		{ DIO32_GSC_OCR,			0x01230123,	0x33333333		},

		{ DIO32_GSC_DGCR,			0x5555AAA5,	0xFFFFFFFF		},

		{ DIO32_GSC_LHIER,			0xFFFFFFFF,	0xFFFFFFFF		},
		{ DIO32_GSC_HLIER,			0xFFFFFFFF,	0xFFFFFFFF		},

		{ DIO32_GSC_D00LHOMR,		0x1155AA00,	0xFFFFFFFF		},
		{ DIO32_GSC_D00LHOVR,		0x2255AA00,	0xFFFFFFFF		},
		{ DIO32_GSC_D00LHOTSR,		0x3355AA00,	0xFFFFFFFF		},
		{ DIO32_GSC_D00HLOMR,		0x4455AA00,	0xFFFFFFFF		},
		{ DIO32_GSC_D00HLOVR,		0x5555AA00,	0xFFFFFFFF		},
		{ DIO32_GSC_D00HLOTSR,		0x6655AA00,	0xFFFFFFFF		},

		{ DIO32_GSC_D01LHOMR,		0x1155AA01,	0xFFFFFFFF		},
		{ DIO32_GSC_D01LHOVR,		0x2255AA01,	0xFFFFFFFF		},
		{ DIO32_GSC_D01LHOTSR,		0x3355AA01,	0xFFFFFFFF		},
		{ DIO32_GSC_D01HLOMR,		0x4455AA01,	0xFFFFFFFF		},
		{ DIO32_GSC_D01HLOVR,		0x5555AA01,	0xFFFFFFFF		},
		{ DIO32_GSC_D01HLOTSR,		0x6655AA01,	0xFFFFFFFF		},

		{ DIO32_GSC_D02LHOMR,		0x1155AA02,	0xFFFFFFFF		},
		{ DIO32_GSC_D02LHOVR,		0x2255AA02,	0xFFFFFFFF		},
		{ DIO32_GSC_D02LHOTSR,		0x3355AA02,	0xFFFFFFFF		},
		{ DIO32_GSC_D02HLOMR,		0x4455AA02,	0xFFFFFFFF		},
		{ DIO32_GSC_D02HLOVR,		0x5555AA02,	0xFFFFFFFF		},
		{ DIO32_GSC_D02HLOTSR,		0x6655AA02,	0xFFFFFFFF		},

		{ DIO32_GSC_D03LHOMR,		0x1155AA03,	0xFFFFFFFF		},
		{ DIO32_GSC_D03LHOVR,		0x2255AA03,	0xFFFFFFFF		},
		{ DIO32_GSC_D03LHOTSR,		0x3355AA03,	0xFFFFFFFF		},
		{ DIO32_GSC_D03HLOMR,		0x4455AA03,	0xFFFFFFFF		},
		{ DIO32_GSC_D03HLOVR,		0x5555AA03,	0xFFFFFFFF		},
		{ DIO32_GSC_D03HLOTSR,		0x6655AA03,	0xFFFFFFFF		},

		{ DIO32_GSC_D04LHOMR,		0x1155AA04,	0xFFFFFFFF		},
		{ DIO32_GSC_D04LHOVR,		0x2255AA04,	0xFFFFFFFF		},
		{ DIO32_GSC_D04LHOTSR,		0x3355AA04,	0xFFFFFFFF		},
		{ DIO32_GSC_D04HLOMR,		0x4455AA04,	0xFFFFFFFF		},
		{ DIO32_GSC_D04HLOVR,		0x5555AA04,	0xFFFFFFFF		},
		{ DIO32_GSC_D04HLOTSR,		0x6655AA04,	0xFFFFFFFF		},

		{ DIO32_GSC_D05LHOMR,		0x1155AA05,	0xFFFFFFFF		},
		{ DIO32_GSC_D05LHOVR,		0x2255AA05,	0xFFFFFFFF		},
		{ DIO32_GSC_D05LHOTSR,		0x3355AA05,	0xFFFFFFFF		},
		{ DIO32_GSC_D05HLOMR,		0x4455AA05,	0xFFFFFFFF		},
		{ DIO32_GSC_D05HLOVR,		0x5555AA05,	0xFFFFFFFF		},
		{ DIO32_GSC_D05HLOTSR,		0x6655AA05,	0xFFFFFFFF		},

		{ DIO32_GSC_D06LHOMR,		0x1155AA06,	0xFFFFFFFF		},
		{ DIO32_GSC_D06LHOVR,		0x2255AA06,	0xFFFFFFFF		},
		{ DIO32_GSC_D06LHOTSR,		0x3355AA06,	0xFFFFFFFF		},
		{ DIO32_GSC_D06HLOMR,		0x4455AA06,	0xFFFFFFFF		},
		{ DIO32_GSC_D06HLOVR,		0x5555AA06,	0xFFFFFFFF		},
		{ DIO32_GSC_D06HLOTSR,		0x6655AA06,	0xFFFFFFFF		},

		{ DIO32_GSC_D07LHOMR,		0x1155AA07,	0xFFFFFFFF		},
		{ DIO32_GSC_D07LHOVR,		0x2255AA07,	0xFFFFFFFF		},
		{ DIO32_GSC_D07LHOTSR,		0x3355AA07,	0xFFFFFFFF		},
		{ DIO32_GSC_D07HLOMR,		0x4455AA07,	0xFFFFFFFF		},
		{ DIO32_GSC_D07HLOVR,		0x5555AA07,	0xFFFFFFFF		},
		{ DIO32_GSC_D07HLOTSR,		0x6655AA07,	0xFFFFFFFF		},

		{ DIO32_GSC_D08LHOMR,		0x1155AA08,	0xFFFFFFFF		},
		{ DIO32_GSC_D08LHOVR,		0x2255AA08,	0xFFFFFFFF		},
		{ DIO32_GSC_D08LHOTSR,		0x3355AA08,	0xFFFFFFFF		},
		{ DIO32_GSC_D08HLOMR,		0x4455AA08,	0xFFFFFFFF		},
		{ DIO32_GSC_D08HLOVR,		0x5555AA08,	0xFFFFFFFF		},
		{ DIO32_GSC_D08HLOTSR,		0x6655AA08,	0xFFFFFFFF		},

		{ DIO32_GSC_D09LHOMR,		0x1155AA09,	0xFFFFFFFF		},
		{ DIO32_GSC_D09LHOVR,		0x2255AA09,	0xFFFFFFFF		},
		{ DIO32_GSC_D09LHOTSR,		0x3355AA09,	0xFFFFFFFF		},
		{ DIO32_GSC_D09HLOMR,		0x4455AA09,	0xFFFFFFFF		},
		{ DIO32_GSC_D09HLOVR,		0x5555AA09,	0xFFFFFFFF		},
		{ DIO32_GSC_D09HLOTSR,		0x6655AA09,	0xFFFFFFFF		},

		{ DIO32_GSC_D10LHOMR,		0x1155AA10,	0xFFFFFFFF		},
		{ DIO32_GSC_D10LHOVR,		0x2255AA10,	0xFFFFFFFF		},
		{ DIO32_GSC_D10LHOTSR,		0x3355AA10,	0xFFFFFFFF		},
		{ DIO32_GSC_D10HLOMR,		0x4455AA10,	0xFFFFFFFF		},
		{ DIO32_GSC_D10HLOVR,		0x5555AA10,	0xFFFFFFFF		},
		{ DIO32_GSC_D10HLOTSR,		0x6655AA10,	0xFFFFFFFF		},

		{ DIO32_GSC_D11LHOMR,		0x1155AA11,	0xFFFFFFFF		},
		{ DIO32_GSC_D11LHOVR,		0x2255AA11,	0xFFFFFFFF		},
		{ DIO32_GSC_D11LHOTSR,		0x3355AA11,	0xFFFFFFFF		},
		{ DIO32_GSC_D11HLOMR,		0x4455AA11,	0xFFFFFFFF		},
		{ DIO32_GSC_D11HLOVR,		0x5555AA11,	0xFFFFFFFF		},
		{ DIO32_GSC_D11HLOTSR,		0x6655AA11,	0xFFFFFFFF		},

		{ DIO32_GSC_D12LHOMR,		0x1155AA12,	0xFFFFFFFF		},
		{ DIO32_GSC_D12LHOVR,		0x2255AA12,	0xFFFFFFFF		},
		{ DIO32_GSC_D12LHOTSR,		0x3355AA12,	0xFFFFFFFF		},
		{ DIO32_GSC_D12HLOMR,		0x4455AA12,	0xFFFFFFFF		},
		{ DIO32_GSC_D12HLOVR,		0x5555AA12,	0xFFFFFFFF		},
		{ DIO32_GSC_D12HLOTSR,		0x6655AA12,	0xFFFFFFFF		},

		{ DIO32_GSC_D13LHOMR,		0x1155AA13,	0xFFFFFFFF		},
		{ DIO32_GSC_D13LHOVR,		0x2255AA13,	0xFFFFFFFF		},
		{ DIO32_GSC_D13LHOTSR,		0x3355AA13,	0xFFFFFFFF		},
		{ DIO32_GSC_D13HLOMR,		0x4455AA13,	0xFFFFFFFF		},
		{ DIO32_GSC_D13HLOVR,		0x5555AA13,	0xFFFFFFFF		},
		{ DIO32_GSC_D13HLOTSR,		0x6655AA13,	0xFFFFFFFF		},

		{ DIO32_GSC_D14LHOMR,		0x1155AA14,	0xFFFFFFFF		},
		{ DIO32_GSC_D14LHOVR,		0x2255AA14,	0xFFFFFFFF		},
		{ DIO32_GSC_D14LHOTSR,		0x3355AA14,	0xFFFFFFFF		},
		{ DIO32_GSC_D14HLOMR,		0x4455AA14,	0xFFFFFFFF		},
		{ DIO32_GSC_D14HLOVR,		0x5555AA14,	0xFFFFFFFF		},
		{ DIO32_GSC_D14HLOTSR,		0x6655AA14,	0xFFFFFFFF		},

		{ DIO32_GSC_D15LHOMR,		0x1155AA15,	0xFFFFFFFF		},
		{ DIO32_GSC_D15LHOVR,		0x2255AA15,	0xFFFFFFFF		},
		{ DIO32_GSC_D15LHOTSR,		0x3355AA15,	0xFFFFFFFF		},
		{ DIO32_GSC_D15HLOMR,		0x4455AA15,	0xFFFFFFFF		},
		{ DIO32_GSC_D15HLOVR,		0x5555AA15,	0xFFFFFFFF		},
		{ DIO32_GSC_D15HLOTSR,		0x6655AA15,	0xFFFFFFFF		},

		{ DIO32_GSC_D16LHOMR,		0x1155AA16,	0xFFFFFFFF		},
		{ DIO32_GSC_D16LHOVR,		0x2255AA16,	0xFFFFFFFF		},
		{ DIO32_GSC_D16LHOTSR,		0x3355AA16,	0xFFFFFFFF		},
		{ DIO32_GSC_D16HLOMR,		0x4455AA16,	0xFFFFFFFF		},
		{ DIO32_GSC_D16HLOVR,		0x5555AA16,	0xFFFFFFFF		},
		{ DIO32_GSC_D16HLOTSR,		0x6655AA16,	0xFFFFFFFF		},

		{ DIO32_GSC_D17LHOMR,		0x1155AA17,	0xFFFFFFFF		},
		{ DIO32_GSC_D17LHOVR,		0x2255AA17,	0xFFFFFFFF		},
		{ DIO32_GSC_D17LHOTSR,		0x3355AA17,	0xFFFFFFFF		},
		{ DIO32_GSC_D17HLOMR,		0x4455AA17,	0xFFFFFFFF		},
		{ DIO32_GSC_D17HLOVR,		0x5555AA17,	0xFFFFFFFF		},
		{ DIO32_GSC_D17HLOTSR,		0x6655AA17,	0xFFFFFFFF		},

		{ DIO32_GSC_D18LHOMR,		0x1155AA18,	0xFFFFFFFF		},
		{ DIO32_GSC_D18LHOVR,		0x2255AA18,	0xFFFFFFFF		},
		{ DIO32_GSC_D18LHOTSR,		0x3355AA18,	0xFFFFFFFF		},
		{ DIO32_GSC_D18HLOMR,		0x4455AA18,	0xFFFFFFFF		},
		{ DIO32_GSC_D18HLOVR,		0x5555AA18,	0xFFFFFFFF		},
		{ DIO32_GSC_D18HLOTSR,		0x6655AA18,	0xFFFFFFFF		},

		{ DIO32_GSC_D19LHOMR,		0x1155AA19,	0xFFFFFFFF		},
		{ DIO32_GSC_D19LHOVR,		0x2255AA19,	0xFFFFFFFF		},
		{ DIO32_GSC_D19LHOTSR,		0x3355AA19,	0xFFFFFFFF		},
		{ DIO32_GSC_D19HLOMR,		0x4455AA19,	0xFFFFFFFF		},
		{ DIO32_GSC_D19HLOVR,		0x5555AA19,	0xFFFFFFFF		},
		{ DIO32_GSC_D19HLOTSR,		0x6655AA19,	0xFFFFFFFF		},

		{ DIO32_GSC_D20LHOMR,		0x1155AA20,	0xFFFFFFFF		},
		{ DIO32_GSC_D20LHOVR,		0x2255AA20,	0xFFFFFFFF		},
		{ DIO32_GSC_D20LHOTSR,		0x3355AA20,	0xFFFFFFFF		},
		{ DIO32_GSC_D20HLOMR,		0x4455AA20,	0xFFFFFFFF		},
		{ DIO32_GSC_D20HLOVR,		0x5555AA20,	0xFFFFFFFF		},
		{ DIO32_GSC_D20HLOTSR,		0x6655AA20,	0xFFFFFFFF		},

		{ DIO32_GSC_D21LHOMR,		0x1155AA21,	0xFFFFFFFF		},
		{ DIO32_GSC_D21LHOVR,		0x2255AA21,	0xFFFFFFFF		},
		{ DIO32_GSC_D21LHOTSR,		0x3355AA21,	0xFFFFFFFF		},
		{ DIO32_GSC_D21HLOMR,		0x4455AA21,	0xFFFFFFFF		},
		{ DIO32_GSC_D21HLOVR,		0x5555AA21,	0xFFFFFFFF		},
		{ DIO32_GSC_D21HLOTSR,		0x6655AA21,	0xFFFFFFFF		},

		{ DIO32_GSC_D22LHOMR,		0x1155AA22,	0xFFFFFFFF		},
		{ DIO32_GSC_D22LHOVR,		0x2255AA22,	0xFFFFFFFF		},
		{ DIO32_GSC_D22LHOTSR,		0x3355AA22,	0xFFFFFFFF		},
		{ DIO32_GSC_D22HLOMR,		0x4455AA22,	0xFFFFFFFF		},
		{ DIO32_GSC_D22HLOVR,		0x5555AA22,	0xFFFFFFFF		},
		{ DIO32_GSC_D22HLOTSR,		0x6655AA22,	0xFFFFFFFF		},

		{ DIO32_GSC_D23LHOMR,		0x1155AA23,	0xFFFFFFFF		},
		{ DIO32_GSC_D23LHOVR,		0x2255AA23,	0xFFFFFFFF		},
		{ DIO32_GSC_D23LHOTSR,		0x3355AA23,	0xFFFFFFFF		},
		{ DIO32_GSC_D23HLOMR,		0x4455AA23,	0xFFFFFFFF		},
		{ DIO32_GSC_D23HLOVR,		0x5555AA23,	0xFFFFFFFF		},
		{ DIO32_GSC_D23HLOTSR,		0x6655AA23,	0xFFFFFFFF		},

		{ DIO32_GSC_D24LHOMR,		0x1155AA24,	0xFFFFFFFF		},
		{ DIO32_GSC_D24LHOVR,		0x2255AA24,	0xFFFFFFFF		},
		{ DIO32_GSC_D24LHOTSR,		0x3355AA24,	0xFFFFFFFF		},
		{ DIO32_GSC_D24HLOMR,		0x4455AA24,	0xFFFFFFFF		},
		{ DIO32_GSC_D24HLOVR,		0x5555AA24,	0xFFFFFFFF		},
		{ DIO32_GSC_D24HLOTSR,		0x6655AA24,	0xFFFFFFFF		},

		{ DIO32_GSC_D25LHOMR,		0x1155AA25,	0xFFFFFFFF		},
		{ DIO32_GSC_D25LHOVR,		0x2255AA25,	0xFFFFFFFF		},
		{ DIO32_GSC_D25LHOTSR,		0x3355AA25,	0xFFFFFFFF		},
		{ DIO32_GSC_D25HLOMR,		0x4455AA25,	0xFFFFFFFF		},
		{ DIO32_GSC_D25HLOVR,		0x5555AA25,	0xFFFFFFFF		},
		{ DIO32_GSC_D25HLOTSR,		0x6655AA25,	0xFFFFFFFF		},

		{ DIO32_GSC_D26LHOMR,		0x1155AA26,	0xFFFFFFFF		},
		{ DIO32_GSC_D26LHOVR,		0x2255AA26,	0xFFFFFFFF		},
		{ DIO32_GSC_D26LHOTSR,		0x3355AA26,	0xFFFFFFFF		},
		{ DIO32_GSC_D26HLOMR,		0x4455AA26,	0xFFFFFFFF		},
		{ DIO32_GSC_D26HLOVR,		0x5555AA26,	0xFFFFFFFF		},
		{ DIO32_GSC_D26HLOTSR,		0x6655AA26,	0xFFFFFFFF		},

		{ DIO32_GSC_D27LHOMR,		0x1155AA27,	0xFFFFFFFF		},
		{ DIO32_GSC_D27LHOVR,		0x2255AA27,	0xFFFFFFFF		},
		{ DIO32_GSC_D27LHOTSR,		0x3355AA27,	0xFFFFFFFF		},
		{ DIO32_GSC_D27HLOMR,		0x4455AA27,	0xFFFFFFFF		},
		{ DIO32_GSC_D27HLOVR,		0x5555AA27,	0xFFFFFFFF		},
		{ DIO32_GSC_D27HLOTSR,		0x6655AA27,	0xFFFFFFFF		},

		{ DIO32_GSC_D28LHOMR,		0x1155AA28,	0xFFFFFFFF		},
		{ DIO32_GSC_D28LHOVR,		0x2255AA28,	0xFFFFFFFF		},
		{ DIO32_GSC_D28LHOTSR,		0x3355AA28,	0xFFFFFFFF		},
		{ DIO32_GSC_D28HLOMR,		0x4455AA28,	0xFFFFFFFF		},
		{ DIO32_GSC_D28HLOVR,		0x5555AA28,	0xFFFFFFFF		},
		{ DIO32_GSC_D28HLOTSR,		0x6655AA28,	0xFFFFFFFF		},

		{ DIO32_GSC_D29LHOMR,		0x1155AA29,	0xFFFFFFFF		},
		{ DIO32_GSC_D29LHOVR,		0x2255AA29,	0xFFFFFFFF		},
		{ DIO32_GSC_D29LHOTSR,		0x3355AA29,	0xFFFFFFFF		},
		{ DIO32_GSC_D29HLOMR,		0x4455AA29,	0xFFFFFFFF		},
		{ DIO32_GSC_D29HLOVR,		0x5555AA29,	0xFFFFFFFF		},
		{ DIO32_GSC_D29HLOTSR,		0x6655AA29,	0xFFFFFFFF		},

		{ DIO32_GSC_D30LHOMR,		0x1155AA30,	0xFFFFFFFF		},
		{ DIO32_GSC_D30LHOVR,		0x2255AA30,	0xFFFFFFFF		},
		{ DIO32_GSC_D30LHOTSR,		0x3355AA30,	0xFFFFFFFF		},
		{ DIO32_GSC_D30HLOMR,		0x4455AA30,	0xFFFFFFFF		},
		{ DIO32_GSC_D30HLOVR,		0x5555AA30,	0xFFFFFFFF		},
		{ DIO32_GSC_D30HLOTSR,		0x6655AA30,	0xFFFFFFFF		},

		{ DIO32_GSC_D31LHOMR,		0x1155AA31,	0xFFFFFFFF		},
		{ DIO32_GSC_D31LHOVR,		0x2255AA31,	0xFFFFFFFF		},
		{ DIO32_GSC_D31LHOTSR,		0x3355AA31,	0xFFFFFFFF		},
		{ DIO32_GSC_D31HLOMR,		0x4455AA31,	0xFFFFFFFF		},
		{ DIO32_GSC_D31HLOVR,		0x5555AA31,	0xFFFFFFFF		},
		{ DIO32_GSC_D31HLOTSR,		0x6655AA31,	0xFFFFFFFF		},
	};

	int			errs	= 0;
	int			i;
	const char*	name;
	gsc_reg_t	parm;
	int			ret;

	errs	+= dio32_initialize(fd, -1, 0);

	// Write the values to the listed registers.

	for (i = 0; i < SIZEOF_ARRAY(list); i++)
	{
		name		= dio32_reg_get_name(list[i].reg);
		parm.reg	= list[i].reg;
		parm.value	= list[i].value;
		parm.mask	= 0xBEEFDEAD;
		ret			= dio32_ioctl(fd, DIO32_IOCTL_REG_WRITE, (void*) &parm);

		if (ret)
		{
			errs++;
			printf(	"FAIL <---  (%d. %s: dio32_ioctl() failure, error %d)\n",
					__LINE__,
					name,
					ret);
			continue;
		}

		if (parm.mask != 0xBEEFDEAD)
		{
			errs	= 1;
			printf("FAIL <---  (%d. %s: mask changed)\n", __LINE__, name);
			continue;
		}
	}

	// Read the registers and verify the specified bits.

	for (i = 0; i < SIZEOF_ARRAY(list); i++)
	{
		name		= dio32_reg_get_name(list[i].reg);
		parm.reg	= list[i].reg;
		parm.value	= 0xBEEFDEAD;
		parm.mask	= 0xBEEFDEAD;
		ret			= dio32_ioctl(fd, DIO32_IOCTL_REG_READ, (void*) &parm);

		if (ret)
		{
			errs++;
			printf(	"FAIL <---  (%d. %s: dio32_ioctl() failure, error %d)\n",
					__LINE__,
					name,
					ret);
			continue;
		}

		if ((list[i].value & list[i].mask) != (parm.value & list[i].mask))
		{
			errs	= 1;
			printf(	"FAIL <---  (%d. %s: mask 0x%08lX, got 0x%08lX, expected 0x%08lX)\n",
					__LINE__,
					name,
					(long) list[i].mask,
					(long) parm.value,
					(long) list[i].value);
			continue;
		}
	}

	errs	+= dio32_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	reg_write_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_REG_WRITE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int reg_write_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_REG_WRITE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


