// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/samples/sbtest/wait_event.c $
// $Rev: 54538 $
// $Date: 2024-05-28 09:36:47 -0500 (Tue, 28 May 2024) $

// DIO32: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	_1_SEC		(1000L)
#define	_15_SEC		(15L * _1_SEC)
#define	_30_SEC		(30L * _1_SEC)



// variables ******************************************************************

static	os_sem_t		sem_enter;
static	os_sem_t		sem_exit;
static	dio32_wait_t	wait_dst;
static	int				wait_fd;



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no settings bits to test here.
	return(0);
}



//*****************************************************************************
static int _cause_hl_irq(int fd, u32 mask)
{
	int	errs	= 0;

	// Prepare the device for the interrupt.
	errs	+= dio32_initialize			(fd, -1, 0);
	errs	+= dio32_deglitch_filter	(fd, -1, 0, 0, NULL);
	errs	+= dio32_deglitch_rate		(fd, -1, 0, 0, NULL);
	errs	+= dio32_io_out_clock		(fd, -1, 0, -1, DIO32_ACT_TX, 0x11111111, DIO32_IO_OUT_CLOCK_NONE, NULL);
	errs	+= dio32_io_out_dir			(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0xFFFFFFFF, NULL);
	errs	+= dio32_io_out_tri_state	(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0, NULL);
	errs	+= dio32_io_out_val			(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0xFFFFFFFF, NULL);

	// Generate the interrupt via the outputs.
	errs	+= dio32_irq_hl_enable		(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, mask, NULL);
	errs	+= dio32_io_out_val			(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, ~mask, NULL);
	return(errs);
}



//*****************************************************************************
static int _cause_lh_irq(int fd, u32 mask)
{
	int	errs	= 0;

	// Prepare the device for the interrupt.
	errs	+= dio32_initialize			(fd, -1, 0);
	errs	+= dio32_deglitch_filter	(fd, -1, 0, 0, NULL);
	errs	+= dio32_deglitch_rate		(fd, -1, 0, 0, NULL);
	errs	+= dio32_io_out_clock		(fd, -1, 0, -1, DIO32_ACT_TX, 0x11111111, DIO32_IO_OUT_CLOCK_NONE, NULL);
	errs	+= dio32_io_out_dir			(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0xFFFFFFFF, NULL);
	errs	+= dio32_io_out_tri_state	(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0, NULL);
	errs	+= dio32_io_out_val			(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, 0, NULL);

	// Generate the interrupt.
	errs	+= dio32_irq_lh_enable		(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, mask, NULL);
	errs	+= dio32_io_out_val			(fd, -1, 0, -1, DIO32_ACT_TX, 0xFFFFFFFF, mask, NULL);

	return(errs);
}



//*****************************************************************************
static int _wait_main_gsc(int fd)
{
	int	errs	= 0;

	errs	+= _cause_hl_irq(fd, D0);
	return(errs);
}



//*****************************************************************************
static int _wait_hl_irq	   (int fd){int	errs = _cause_hl_irq(fd, D0);	return(errs); }
static int _wait_hl_d00_irq(int fd){int	errs = _cause_hl_irq(fd, D0);	return(errs); }
static int _wait_hl_d01_irq(int fd){int	errs = _cause_hl_irq(fd, D1);	return(errs); }
static int _wait_hl_d02_irq(int fd){int	errs = _cause_hl_irq(fd, D2);	return(errs); }
static int _wait_hl_d03_irq(int fd){int	errs = _cause_hl_irq(fd, D3);	return(errs); }
static int _wait_hl_d04_irq(int fd){int	errs = _cause_hl_irq(fd, D4);	return(errs); }
static int _wait_hl_d05_irq(int fd){int	errs = _cause_hl_irq(fd, D5);	return(errs); }
static int _wait_hl_d06_irq(int fd){int	errs = _cause_hl_irq(fd, D6);	return(errs); }
static int _wait_hl_d07_irq(int fd){int	errs = _cause_hl_irq(fd, D7);	return(errs); }
static int _wait_hl_d08_irq(int fd){int	errs = _cause_hl_irq(fd, D8);	return(errs); }
static int _wait_hl_d09_irq(int fd){int	errs = _cause_hl_irq(fd, D9);	return(errs); }
static int _wait_hl_d10_irq(int fd){int	errs = _cause_hl_irq(fd, D10);	return(errs); }
static int _wait_hl_d11_irq(int fd){int	errs = _cause_hl_irq(fd, D11);	return(errs); }
static int _wait_hl_d12_irq(int fd){int	errs = _cause_hl_irq(fd, D12);	return(errs); }
static int _wait_hl_d13_irq(int fd){int	errs = _cause_hl_irq(fd, D13);	return(errs); }
static int _wait_hl_d14_irq(int fd){int	errs = _cause_hl_irq(fd, D14);	return(errs); }
static int _wait_hl_d15_irq(int fd){int	errs = _cause_hl_irq(fd, D15);	return(errs); }
static int _wait_hl_d16_irq(int fd){int	errs = _cause_hl_irq(fd, D16);	return(errs); }
static int _wait_hl_d17_irq(int fd){int	errs = _cause_hl_irq(fd, D17);	return(errs); }
static int _wait_hl_d18_irq(int fd){int	errs = _cause_hl_irq(fd, D18);	return(errs); }
static int _wait_hl_d19_irq(int fd){int	errs = _cause_hl_irq(fd, D19);	return(errs); }
static int _wait_hl_d20_irq(int fd){int	errs = _cause_hl_irq(fd, D20);	return(errs); }
static int _wait_hl_d21_irq(int fd){int	errs = _cause_hl_irq(fd, D21);	return(errs); }
static int _wait_hl_d22_irq(int fd){int	errs = _cause_hl_irq(fd, D22);	return(errs); }
static int _wait_hl_d23_irq(int fd){int	errs = _cause_hl_irq(fd, D23);	return(errs); }
static int _wait_hl_d24_irq(int fd){int	errs = _cause_hl_irq(fd, D24);	return(errs); }
static int _wait_hl_d25_irq(int fd){int	errs = _cause_hl_irq(fd, D25);	return(errs); }
static int _wait_hl_d26_irq(int fd){int	errs = _cause_hl_irq(fd, D26);	return(errs); }
static int _wait_hl_d27_irq(int fd){int	errs = _cause_hl_irq(fd, D27);	return(errs); }
static int _wait_hl_d28_irq(int fd){int	errs = _cause_hl_irq(fd, D28);	return(errs); }
static int _wait_hl_d29_irq(int fd){int	errs = _cause_hl_irq(fd, D29);	return(errs); }
static int _wait_hl_d30_irq(int fd){int	errs = _cause_hl_irq(fd, D30);	return(errs); }
static int _wait_hl_d31_irq(int fd){int	errs = _cause_hl_irq(fd, D31);	return(errs); }



//*****************************************************************************
static int _wait_lh_irq	   (int fd){int	errs = _cause_lh_irq(fd, D0); 	return(errs); }
static int _wait_lh_d00_irq(int fd){int	errs = _cause_lh_irq(fd, D0);	return(errs); }
static int _wait_lh_d01_irq(int fd){int	errs = _cause_lh_irq(fd, D1);	return(errs); }
static int _wait_lh_d02_irq(int fd){int	errs = _cause_lh_irq(fd, D2);	return(errs); }
static int _wait_lh_d03_irq(int fd){int	errs = _cause_lh_irq(fd, D3);	return(errs); }
static int _wait_lh_d04_irq(int fd){int	errs = _cause_lh_irq(fd, D4);	return(errs); }
static int _wait_lh_d05_irq(int fd){int	errs = _cause_lh_irq(fd, D5);	return(errs); }
static int _wait_lh_d06_irq(int fd){int	errs = _cause_lh_irq(fd, D6);	return(errs); }
static int _wait_lh_d07_irq(int fd){int	errs = _cause_lh_irq(fd, D7);	return(errs); }
static int _wait_lh_d08_irq(int fd){int	errs = _cause_lh_irq(fd, D8);	return(errs); }
static int _wait_lh_d09_irq(int fd){int	errs = _cause_lh_irq(fd, D9);	return(errs); }
static int _wait_lh_d10_irq(int fd){int	errs = _cause_lh_irq(fd, D10);	return(errs); }
static int _wait_lh_d11_irq(int fd){int	errs = _cause_lh_irq(fd, D11);	return(errs); }
static int _wait_lh_d12_irq(int fd){int	errs = _cause_lh_irq(fd, D12);	return(errs); }
static int _wait_lh_d13_irq(int fd){int	errs = _cause_lh_irq(fd, D13);	return(errs); }
static int _wait_lh_d14_irq(int fd){int	errs = _cause_lh_irq(fd, D14);	return(errs); }
static int _wait_lh_d15_irq(int fd){int	errs = _cause_lh_irq(fd, D15);	return(errs); }
static int _wait_lh_d16_irq(int fd){int	errs = _cause_lh_irq(fd, D16);	return(errs); }
static int _wait_lh_d17_irq(int fd){int	errs = _cause_lh_irq(fd, D17);	return(errs); }
static int _wait_lh_d18_irq(int fd){int	errs = _cause_lh_irq(fd, D18);	return(errs); }
static int _wait_lh_d19_irq(int fd){int	errs = _cause_lh_irq(fd, D19);	return(errs); }
static int _wait_lh_d20_irq(int fd){int	errs = _cause_lh_irq(fd, D20);	return(errs); }
static int _wait_lh_d21_irq(int fd){int	errs = _cause_lh_irq(fd, D21);	return(errs); }
static int _wait_lh_d22_irq(int fd){int	errs = _cause_lh_irq(fd, D22);	return(errs); }
static int _wait_lh_d23_irq(int fd){int	errs = _cause_lh_irq(fd, D23);	return(errs); }
static int _wait_lh_d24_irq(int fd){int	errs = _cause_lh_irq(fd, D24);	return(errs); }
static int _wait_lh_d25_irq(int fd){int	errs = _cause_lh_irq(fd, D25);	return(errs); }
static int _wait_lh_d26_irq(int fd){int	errs = _cause_lh_irq(fd, D26);	return(errs); }
static int _wait_lh_d27_irq(int fd){int	errs = _cause_lh_irq(fd, D27);	return(errs); }
static int _wait_lh_d28_irq(int fd){int	errs = _cause_lh_irq(fd, D28);	return(errs); }
static int _wait_lh_d29_irq(int fd){int	errs = _cause_lh_irq(fd, D29);	return(errs); }
static int _wait_lh_d30_irq(int fd){int	errs = _cause_lh_irq(fd, D30);	return(errs); }
static int _wait_lh_d31_irq(int fd){int	errs = _cause_lh_irq(fd, D31);	return(errs); }



//*****************************************************************************
static int _wait_thread(void* arg)
{
	int	errs;
	int	ret;

	os_sem_unlock(&sem_enter);
	ret		= dio32_ioctl(wait_fd, DIO32_IOCTL_WAIT_EVENT, &wait_dst);
	errs	= ret ? 1 : 0;

	if (ret)
		wait_dst.flags	= 0xFFFFFFFF;

	os_sem_unlock(&sem_exit);
	return(errs);
}



//*****************************************************************************
static int	_wait_timeout(int fd)
{
	os_sleep_ms(2000);
	return(0);
}



//*****************************************************************************
static int	_wait_cancel(int fd)
{
	int				ret;
	dio32_wait_t	wait;

	wait.flags			= 0;
	wait.main			= 0xFFFFFFFF;
	wait.gsc			= 0xFFFFFFFF;
	wait.hi_low			= 0xFFFFFFFF;
	wait.low_hi			= 0xFFFFFFFF;
	wait.timeout_ms		= 0;
	wait.count			= 0;
	ret					= dio32_ioctl(wait_fd, DIO32_IOCTL_WAIT_CANCEL, &wait);
	return(ret);
}



// variables ******************************************************************

static const struct
{
	const char*		name;
	int				(*function)(int fd);
	dio32_wait_t	wait;
} wait_src[]	=
{
	// name				function			flags			main					...			timeout_ms
	{ "GSC",			_wait_main_gsc,		{ 0,			GSC_WAIT_MAIN_GSC,		0, 0, 0,	_15_SEC	}	},

	// name				function			flags ...		gsc						...			timeout_ms
	{ "High-Low",		_wait_hl_irq,		{ 0, 0,			DIO32_WAIT_GSC_HI_LOW,	0, 0,		_15_SEC	}	},
	{ "Low-High",		_wait_lh_irq,		{ 0, 0,			DIO32_WAIT_GSC_LOW_HI,	0, 0,		_15_SEC	}	},

	// name				function			flags ...		hi_low						...			timeout_ms
	{ "High-Low D0",	_wait_hl_d00_irq,	{ 0, 0, 0,		D0,						0,			_15_SEC	}	},
	{ "High-Low D1",	_wait_hl_d01_irq,	{ 0, 0, 0,		D1,						0,			_15_SEC	}	},
	{ "High-Low D2",	_wait_hl_d02_irq,	{ 0, 0, 0,		D2,						0,			_15_SEC	}	},
	{ "High-Low D3",	_wait_hl_d03_irq,	{ 0, 0, 0,		D3,						0,			_15_SEC	}	},
	{ "High-Low D4",	_wait_hl_d04_irq,	{ 0, 0, 0,		D4,						0,			_15_SEC	}	},
	{ "High-Low D5",	_wait_hl_d05_irq,	{ 0, 0, 0,		D5,						0,			_15_SEC	}	},
	{ "High-Low D6",	_wait_hl_d06_irq,	{ 0, 0, 0,		D6,						0,			_15_SEC	}	},
	{ "High-Low D7",	_wait_hl_d07_irq,	{ 0, 0, 0,		D7,						0,			_15_SEC	}	},
	{ "High-Low D8",	_wait_hl_d08_irq,	{ 0, 0, 0,		D8,						0,			_15_SEC	}	},
	{ "High-Low D9",	_wait_hl_d09_irq,	{ 0, 0, 0,		D9,						0,			_15_SEC	}	},

	{ "High-Low D10",	_wait_hl_d10_irq,	{ 0, 0, 0,		D10,					0,			_15_SEC	}	},
	{ "High-Low D11",	_wait_hl_d11_irq,	{ 0, 0, 0,		D11,					0,			_15_SEC	}	},
	{ "High-Low D12",	_wait_hl_d12_irq,	{ 0, 0, 0,		D12,					0,			_15_SEC	}	},
	{ "High-Low D13",	_wait_hl_d13_irq,	{ 0, 0, 0,		D13,					0,			_15_SEC	}	},
	{ "High-Low D14",	_wait_hl_d14_irq,	{ 0, 0, 0,		D14,					0,			_15_SEC	}	},
	{ "High-Low D15",	_wait_hl_d15_irq,	{ 0, 0, 0,		D15,					0,			_15_SEC	}	},
	{ "High-Low D16",	_wait_hl_d16_irq,	{ 0, 0, 0,		D16,					0,			_15_SEC	}	},
	{ "High-Low D17",	_wait_hl_d17_irq,	{ 0, 0, 0,		D17,					0,			_15_SEC	}	},
	{ "High-Low D18",	_wait_hl_d18_irq,	{ 0, 0, 0,		D18,					0,			_15_SEC	}	},
	{ "High-Low D19",	_wait_hl_d19_irq,	{ 0, 0, 0,		D19,					0,			_15_SEC	}	},

	{ "High-Low D20",	_wait_hl_d20_irq,	{ 0, 0, 0,		D20,					0,			_15_SEC	}	},
	{ "High-Low D21",	_wait_hl_d21_irq,	{ 0, 0, 0,		D21,					0,			_15_SEC	}	},
	{ "High-Low D22",	_wait_hl_d22_irq,	{ 0, 0, 0,		D22,					0,			_15_SEC	}	},
	{ "High-Low D23",	_wait_hl_d23_irq,	{ 0, 0, 0,		D23,					0,			_15_SEC	}	},
	{ "High-Low D24",	_wait_hl_d24_irq,	{ 0, 0, 0,		D24,					0,			_15_SEC	}	},
	{ "High-Low D25",	_wait_hl_d25_irq,	{ 0, 0, 0,		D25,					0,			_15_SEC	}	},
	{ "High-Low D26",	_wait_hl_d26_irq,	{ 0, 0, 0,		D26,					0,			_15_SEC	}	},
	{ "High-Low D27",	_wait_hl_d27_irq,	{ 0, 0, 0,		D27,					0,			_15_SEC	}	},
	{ "High-Low D28",	_wait_hl_d28_irq,	{ 0, 0, 0,		D28,					0,			_15_SEC	}	},
	{ "High-Low D29",	_wait_hl_d29_irq,	{ 0, 0, 0,		D29,					0,			_15_SEC	}	},

	{ "High-Low D30",	_wait_hl_d30_irq,	{ 0, 0, 0,		D30,					0,			_15_SEC	}	},
	{ "High-Low D31",	_wait_hl_d31_irq,	{ 0, 0, 0,		D31,					0,			_15_SEC	}	},

	// name				function			flags ...		low_hi								timeout_ms
	{ "Low-High D0",	_wait_lh_d00_irq,	{ 0, 0, 0, 0,	D0,									_15_SEC	}	},
	{ "Low-High D1",	_wait_lh_d01_irq,	{ 0, 0, 0, 0,	D1,									_15_SEC	}	},
	{ "Low-High D2",	_wait_lh_d02_irq,	{ 0, 0, 0, 0,	D2,									_15_SEC	}	},
	{ "Low-High D3",	_wait_lh_d03_irq,	{ 0, 0, 0, 0,	D3,									_15_SEC	}	},
	{ "Low-High D4",	_wait_lh_d04_irq,	{ 0, 0, 0, 0,	D4,									_15_SEC	}	},
	{ "Low-High D5",	_wait_lh_d05_irq,	{ 0, 0, 0, 0,	D5,									_15_SEC	}	},
	{ "Low-High D6",	_wait_lh_d06_irq,	{ 0, 0, 0, 0,	D6,									_15_SEC	}	},
	{ "Low-High D7",	_wait_lh_d07_irq,	{ 0, 0, 0, 0,	D7,									_15_SEC	}	},
	{ "Low-High D8",	_wait_lh_d08_irq,	{ 0, 0, 0, 0,	D8,									_15_SEC	}	},
	{ "Low-High D9",	_wait_lh_d09_irq,	{ 0, 0, 0, 0,	D9,									_15_SEC	}	},

	{ "Low-High D10",	_wait_lh_d10_irq,	{ 0, 0, 0, 0,	D10,								_15_SEC	}	},
	{ "Low-High D11",	_wait_lh_d11_irq,	{ 0, 0, 0, 0,	D11,								_15_SEC	}	},
	{ "Low-High D12",	_wait_lh_d12_irq,	{ 0, 0, 0, 0,	D12,								_15_SEC	}	},
	{ "Low-High D13",	_wait_lh_d13_irq,	{ 0, 0, 0, 0,	D13,								_15_SEC	}	},
	{ "Low-High D14",	_wait_lh_d14_irq,	{ 0, 0, 0, 0,	D14,								_15_SEC	}	},
	{ "Low-High D15",	_wait_lh_d15_irq,	{ 0, 0, 0, 0,	D15,								_15_SEC	}	},
	{ "Low-High D16",	_wait_lh_d16_irq,	{ 0, 0, 0, 0,	D16,								_15_SEC	}	},
	{ "Low-High D17",	_wait_lh_d17_irq,	{ 0, 0, 0, 0,	D17,								_15_SEC	}	},
	{ "Low-High D18",	_wait_lh_d18_irq,	{ 0, 0, 0, 0,	D18,								_15_SEC	}	},
	{ "Low-High D19",	_wait_lh_d19_irq,	{ 0, 0, 0, 0,	D19,								_15_SEC	}	},

	{ "Low-High D20",	_wait_lh_d20_irq,	{ 0, 0, 0, 0,	D20,								_15_SEC	}	},
	{ "Low-High D21",	_wait_lh_d21_irq,	{ 0, 0, 0, 0,	D21,								_15_SEC	}	},
	{ "Low-High D22",	_wait_lh_d22_irq,	{ 0, 0, 0, 0,	D22,								_15_SEC	}	},
	{ "Low-High D23",	_wait_lh_d23_irq,	{ 0, 0, 0, 0,	D23,								_15_SEC	}	},
	{ "Low-High D24",	_wait_lh_d24_irq,	{ 0, 0, 0, 0,	D24,								_15_SEC	}	},
	{ "Low-High D25",	_wait_lh_d25_irq,	{ 0, 0, 0, 0,	D25,								_15_SEC	}	},
	{ "Low-High D26",	_wait_lh_d26_irq,	{ 0, 0, 0, 0,	D26,								_15_SEC	}	},
	{ "Low-High D27",	_wait_lh_d27_irq,	{ 0, 0, 0, 0,	D27,								_15_SEC	}	},
	{ "Low-High D28",	_wait_lh_d28_irq,	{ 0, 0, 0, 0,	D28,								_15_SEC	}	},
	{ "Low-High D29",	_wait_lh_d29_irq,	{ 0, 0, 0, 0,	D29,								_15_SEC	}	},

	{ "Low-High D30",	_wait_lh_d30_irq,	{ 0, 0, 0, 0,	D30,								_15_SEC	}	},
	{ "Low-High D31",	_wait_lh_d31_irq,	{ 0, 0, 0, 0,	D31,								_15_SEC	}	},

	// name				function			flags ...		low_hi								timeout_ms
	{ "Wait Timeout",	_wait_timeout,		{ 0, 0, 0, 0,	D0,									_1_SEC	}	},
	{ "Wait Cancel",	_wait_cancel,		{ 0, 0, 0, 0,	D0,									_30_SEC	}	},

	// terminate list
	{ NULL, NULL, { 1 } }
};



//*****************************************************************************
static int _process_thread(int fd, int index)
{
	char			buf[64];
	int				errs	= 0;
	int				i;
	int				ret;
	os_thread_t		thread;
	dio32_wait_t	wait;

	errs	+= dio32_initialize(fd, -1, 0);

	for (;;)	// A convenience loop.
	{
		os_sem_create_qty(&sem_enter, 1, 0);
		os_sem_create_qty(&sem_exit, 1, 0);
		memset(&thread, 0, sizeof(thread));
		sprintf(buf, "wait event %d", index);
		wait_dst	= wait_src[index].wait;
		errs		+= os_thread_create(&thread, buf, _wait_thread, NULL);

		// Wait for the thread to become waiting.
		os_sem_lock(&sem_enter);

		if (errs == 0)
		{
			wait	= wait_src[index].wait;

			for (i = 0; i < 100; i++)
			{
				ret	= dio32_ioctl(wait_fd, DIO32_IOCTL_WAIT_STATUS, &wait);

				if (ret)
				{
					printf(	"FAIL <---  (%d. status request %d: error %d)\n",
							__LINE__,
							index,
							ret);
					errs++;
					break;
				}

				if (wait.count == 0)
				{
					os_sleep_ms(100);
					continue;
				}

				if (wait.count == 1)
					break;

				errs++;
				printf(	"FAIL <---  (%d. invalid wait count %ld)\n",
						__LINE__,
						(long) wait.count);
				break;
			}
		}

		// Initiate the respective event.
		errs	+= wait_src[index].function(wait_fd);

		if (errs)
			break;		// There was an error.

		// Wait for the resumed thread to run.
		os_sem_lock(&sem_exit);

		for (i = 0;; i++)
		{
			if (wait_dst.flags)
				break;

			if (i >= 100)
			{
				printf(	"FAIL <---  (%d. thread failed to resume)\n",
						__LINE__);
				errs++;
				break;
			}

			os_sleep_ms(100);
		}

		// Verify that the wait ended as expected.

		if (wait_src[index].wait.flags == 0xFFFFFFFF)
			break;		// There was an error.

		if (errs)
			break;		// There was an error.

		if (wait_src[index].wait.timeout_ms == _1_SEC)
		{
			if (wait_dst.flags != GSC_WAIT_FLAG_TIMEOUT)
			{
				printf(	"FAIL <---  (%d. flag: expect 0x%lX, got 0x%lX)\n",
						__LINE__,
						(long) GSC_WAIT_FLAG_TIMEOUT,
						(long) wait_dst.flags);
				errs++;
			}

			break;
		}

		if (wait_src[index].wait.timeout_ms == _15_SEC)
		{
			if (wait_dst.flags != GSC_WAIT_FLAG_DONE)
			{
				printf(	"FAIL <---  (%d. flag: expect 0x%lX, got 0x%lX)\n",
						__LINE__,
						(long) GSC_WAIT_FLAG_DONE,
						(long) wait_dst.flags);
				errs++;
			}

			break;
		}

		if (wait_src[index].wait.timeout_ms == _30_SEC)
		{
			if (wait_dst.flags != GSC_WAIT_FLAG_CANCEL)
			{
				printf(	"FAIL <---  (%d. flag: expect 0x%lX, got 0x%lX)\n",
						__LINE__,
						(long) GSC_WAIT_FLAG_TIMEOUT,
						(long) wait_dst.flags);
				errs++;
			}

			break;
		}

		printf("FAIL <---  (%d. INTERNAL ERROR)\n", __LINE__);
		errs++;
		break;
	}

	// Force termination, just in case of an error.
	wait.flags			= 0;
	wait.main			= 0xFFFFFFFF;
	wait.gsc			= 0xFFFFFFFF;
	wait.hi_low			= 0xFFFFFFFF;
	wait.low_hi			= 0xFFFFFFFF;
	wait.timeout_ms		= 0;
	wait.count			= 0;
	ret		= dio32_ioctl(wait_fd, DIO32_IOCTL_WAIT_CANCEL, &wait);
	errs	+= ret ? 1 : 0;
	errs	+= os_thread_destroy(&thread);

	errs	+= dio32_initialize(fd, -1, 0);

	if (errs == 0)
		printf("PASS\n");

	os_sem_destroy(&sem_enter);
	os_sem_destroy(&sem_exit);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;
	int	i;

	gsc_label_level_inc();

	// Create threads awaiting each of the source crtiteria
	// and verify that it resumes when the criteria is met.

	for (i = 0; wait_src[i].wait.flags == 0; i++)
	{
		gsc_label(wait_src[i].name);
		wait_fd	= fd;
		memset(&wait_dst, 0, sizeof(wait_dst));
		errs	+= _process_thread(fd, i);
	}

	gsc_label_level_dec();
	return(errs);
}



/******************************************************************************
*
*	Function:	wait_event_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service DIO32_IOCTL_WAIT_EVENT.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int wait_event_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO32_IOCTL_WAIT_EVENT");
	errs	+= _service_test(fd);

	if (errs == 0)
		printf("PASS\n");

	errs	+= _function_test(fd);

	return(errs);
}


