// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO32/DIO32_Linux_1.x_GSC_DN/utils/util_io_in_get.c $
// $Rev: 45663 $
// $Date: 2019-08-05 17:54:20 -0500 (Mon, 05 Aug 2019) $

// DIO32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dio32_io_in_get
*
*	Purpose:
*
*		Provide a visual wrapper for the DIO32_IOCTL_IO_IN_GET service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio32_io_in_get(int fd, int index, int verbose, u32* get)
{
	int	errs;
	u32	set;
	int	ret;

	if (verbose)
		gsc_label_index("Raw Input", index);

	ret		= dio32_ioctl(fd, DIO32_IOCTL_IO_IN_GET, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%08lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


